// -*- mode: objc
// Template application. Copyright (C) 1996 Santa Fe Institute.
// This library is distributed without any warranty; without even the
// implied warranty of merchantability or fitness for a particular purpose.
// See file LICENSE for details and terms of copying.

#import <swarmobject.h>
#import <simtools.h>
#import <analysis.h>
#import "PopSwarm.h"

// Sample graphical interface swarm for models.
@interface PopulationObserverSwarm : GUISwarm {
  int displayFrequency;
  
  id displayActions;
  id displaySchedule;
  
  EZGraph * fitnessGraph;			  // graphing widget

  // MODIFY: add display objects
  unsigned chromLen;
  float (*evalFunc) (id<Chromosome>); // Evaluation Function
  PopulationSwarm * populationSwarm;
}

+createBegin: (id) aZone;
-createEnd;
-buildObjects;
-buildActions;
-activateIn: (id) swarmContext;

// Other methods
-setChromLength: (unsigned) _len;
-setEvaluationFunc: (float(*)( id )) _evalFunc;
-checkToStop;
@end
